from urllib.parse import quote
import requests
import json

# Request parameters
api_key = "PCW45-12345-12345-1234X"
to_mobile = "07500123456"
from_name = "Example.com"
message = "Hello from [from]. Your security code is [otp]. It will expire in [expiry] minutes. Do not share this code."
otp_length = 6
expiry = 5

# Prepare request and encode user-entered parameters with %xx encoding
request_url = f"https://ws.postcoder.com/pcw/{api_key}/otp/send"

request_body = {
    "to": f"{quote(to_mobile, safe='')}",
    "from": f"{quote(from_name, safe='')}",
    "message": f"{quote(message, safe='')}",
    "otplength": otp_length,
    "expiry": expiry
}

# Make request to send OTP via SMS
response = requests.post(request_url, json=request_body)

# Get ID to use with the otp/verify endpoint
if response.status_code == 200:
    json = response.json()
    print(json["id"])
else:
    print(f"Request error: {response.content.decode()}")